// Copyright (C) 2009  Michael Horvath

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

/*
Browser compatibility issues:
	Proprietary:
		srcElement
		filter
		onmouseenter, etc.
		event bubbling
	Version:
		clientWidth, etc.
Other issues:
	Try and use 'if else', 'continue' and 'break' more often.
*/

//---------------------------------------------- Initialization

// Should use arrays instead of these.
var pnlWid = 200,	winWid = 0,	winHgh = 0
var barHgh = 20,	padHgh = 8,	brdHgh = 1
var cllMax = 50,	cllMin = 20
var pnlDat =
{
	det:[200,200,'block'],
	key:[200,200,'block']
}
var tmpX = 0,		tmpY = 0
var cllXNm = 20,	cllYNm = 10
var fillText = 'Information regarding this system will go here.'


//---------------------------------------------- Events

function getElementByEvent(e)
{
	var ev = !e ? window.event : e
	return ev.target ? ev.target : ev.srcElement
}

function initGuide()
{
	Set_Window_Size()
	Write_Guide()
}

function Set_Window_Size()
{
	// Firefox
	if (self.innerHeight)
	{
		winWid = window.innerWidth
		winHgh = window.innerHeight
	}
	// Explorer 6 Strict Mode
	else if (document.documentElement && document.documentElement.clientHeight)
	{
		winWid = document.documentElement.clientWidth
		winHgh = document.documentElement.clientHeight
	}
	// other Explorers
	else if (document.body)
	{
		winWid = document.getElementsByTagName('body')[0].clientWidth
		winHgh = document.getElementsByTagName('body')[0].clientHeight
	}
}

function Highlight_Cll_On(e)
{
	var el = getElementByEvent(e)
	if ((el.className != 'cll') && (el.className != 'ent'))
		return
	var TempId  = el.id
	var TempInt = TempId.length
	var TempStr = TempId.substring(3, TempInt)
	var intX = parseInt(TempId.split('X')[1].split('Y')[0])
	var intY = parseInt(TempId.split('X')[1].split('Y')[1])
	document.getElementById('ovr' + TempStr).style.backgroundColor = '#ffffff'
	if (document.getElementById('rfr' + TempStr))
		document.getElementById('rfr' + TempStr).style.backgroundColor = '#5454DE'
	document.getElementById('hvrX').style.left = intX * cllMax + cllMin - brdHgh + 'px'
	document.getElementById('hvrY').style.top  = intY * cllMax + cllMin - brdHgh + 'px'
}

function Highlight_Cll_Off(e)
{
	var el = getElementByEvent(e)
	if ((el.className != 'cll') && (el.className != 'ent'))
		return
	var TempId  = el.id
	var TempInt = TempId.length
	var TempStr = TempId.substring(3, TempInt)
	document.getElementById('ovr' + TempStr).style.backgroundColor = 'transparent'
	if (document.getElementById('rfr' + TempStr))
		document.getElementById('rfr' + TempStr).style.backgroundColor = 'transparent'
}

function Expand_Ref_Nodes(e)
{
	var el = getElementByEvent(e)
	var TempId = el.id
	if (document.getElementById(TempId + 'In').style.display == 'none')
	{
		document.getElementById(TempId + 'In').style.display = 'block'
		document.getElementById(TempId + 'Dot').firstChild.nodeValue = '\u25a1'
	}
	else
	{
		document.getElementById(TempId + 'In').style.display = 'none'
		document.getElementById(TempId + 'Dot').firstChild.nodeValue = '\u25a0'
	}
}

function Toggle_Key_Items(e)
{
	var el = getElementByEvent(e)
	var TempId = el.id
	var idSub = TempId.substring(3, 5)
	if (document.getElementById(TempId + 'Dot').firstChild.nodeValue == '\u25a0')
	{
		document.getElementById(TempId + 'Dot').firstChild.nodeValue = '\u25a1'
		for (var i = 0, n = secDat.length; i < n; i++)
		{
			var thisSec = secDat[i]
			var thisEmp = empDat[thisSec.Ep]
			if (idSub == 'R' + thisSec.Ep)
			{
				document.getElementById('sqrX' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'none'
				for (var l in facDat)
				{
					if (document.getElementById('rfr' + l + 'X' + thisSec.Cx + 'Y' + thisSec.Cy))
						document.getElementById('rfr' + l + 'X' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'none'
				}
			}
			if (idSub == 'Rc')
			{
				document.getElementById('sqrX' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'none'
				document.getElementById('keyR' + thisSec.Ep + 'Dot').firstChild.nodeValue = '\u25a1'
			}
		}
	}
	else
	{
		document.getElementById(TempId + 'Dot').firstChild.nodeValue = '\u25a0'
		for (var i = 0, n = secDat.length; i < n; i++)
		{
			var thisSec = secDat[i]
			var thisEmp = empDat[thisSec.Ep]
			if (idSub == 'R' + thisSec.Ep)
			{
				document.getElementById('sqrX' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'block'
				for (var l in facDat)
				{
					if (document.getElementById('rfr' + l + 'X' + thisSec.Cx + 'Y' + thisSec.Cy))
						document.getElementById('rfr' + l + 'X' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'block'
				}
			}
			if (idSub == 'Rc')
			{
				document.getElementById('sqrX' + thisSec.Cx + 'Y' + thisSec.Cy).style.display = 'block'
				document.getElementById('keyR' + thisSec.Ep + 'Dot').firstChild.nodeValue = '\u25a0'				
			}
		}
	}
}

function Expand_Rgt_Panels(e)
{
	var el = getElementByEvent(e)
	var TempId = el.id
	var TempEl = document.getElementById(TempId + 'In')
	if (TempEl.style.display == 'block')
	{
		pnlDat[TempId][1] = 0
		pnlDat[TempId][2] = 'none'
		TempEl.style.display = 'none'
	}
	else
	{
		pnlDat[TempId][1] = pnlDat[TempId][0]
		pnlDat[TempId][2] = 'block'
		TempEl.style.display = 'block'
	}
	var tmpHgh = 0
	for (var i in pnlDat)
	{
		if (pnlDat[i][2] == 'block')
			tmpHgh += pnlDat[i][1]
		else
			tmpHgh += barHgh + brdHgh * 2
	}
	document.getElementById('rfrIn').style.height = winHgh - tmpHgh - brdHgh * 2 - padHgh * 2 - barHgh + 'px'
}

function Expand_Rfr_Panel()
{
	var TempEl = document.getElementById('rfrIn')
	if (TempEl.style.display == 'block')
		TempEl.style.display = 'none'
	else
		TempEl.style.display = 'block'
}

function Expand_Map()
{
	if (document.getElementById('panel').style.display == 'block')
	{
		document.getElementById('panel').style.display = 'none'
		document.getElementById('mapBox').style.width  = winWid - brdHgh * 2 + 'px'
		document.getElementById('mapIn').style.width   = winWid - brdHgh * 2 + 'px'
		document.getElementById('map').style.width     = winWid - brdHgh * 4 + 'px'
	}
	else
	{
		document.getElementById('panel').style.display = 'block'
		document.getElementById('mapBox').style.width  = winWid - pnlWid - brdHgh * 2 + 'px'
		document.getElementById('mapIn').style.width   = winWid - pnlWid - brdHgh * 2 + 'px'
		document.getElementById('map').style.width     = winWid - pnlWid - brdHgh * 4 + 'px'
	}                                                              
}

function Select_Cell(e)
{
	var el = getElementByEvent(e)
	var TempId = el.id
	var TempClass = el.className
	var strX = TempId.split('X')[1].split('Y')[0]
	var strY = TempId.split('X')[1].split('Y')[1]
	for (var i = 0, n = secDat.length; i < n; i++)
	{
		var thisSec = secDat[i]
		if ((thisSec.Cx == eval(strX)) && (thisSec.Cy == eval(strY)))
		{
			var thisEmp = empDat[thisSec.Ep]
			for (var j in thisSec)
			{
				var thisSecJ = thisSec[j]
				switch (j)
				{
					case 'Tl' :
					case 'M1' :
					case 'M2' :
						document.getElementById('detnum' + j).innerHTML = thisSecJ
					case 'Sh' :
					case 'Dk' :
					case 'Pr' :
					case 'Xt' :
						document.getElementById('det' + j).style.display = thisSecJ > 0 ? 'block' : 'none'
					break
				}
			}
			document.getElementById('detTi').innerHTML = thisSec.Ti
			document.getElementById('detXY').innerHTML = (thisSec.Cx + 1) + ', ' + (thisSec.Cy + 1)
			document.getElementById('detTx').innerHTML = thisSec.Tx
			document.getElementById('detRc').innerHTML = thisEmp[2] + ' (<span style="font:bold;color:' + thisEmp[0] + ';">' + thisEmp[3] + '</span>)'
			break
		}
	}
	document.getElementById('cllX' + tmpX + 'Y' + tmpY).style.backgroundColor = 'transparent'
	document.getElementById('cllX' + tmpX + 'Y' + tmpY).style.filter = 'Alpha(opacity=100)'
	document.getElementById('cllX' + tmpX + 'Y' + tmpY).style.opacity = '1.00'
	document.getElementById('X' + tmpX).style.backgroundColor = 'transparent'
	document.getElementById('Y' + tmpY).style.backgroundColor = 'transparent'
	document.getElementById('X' + tmpX).style.filter = 'Alpha(opacity=100)'
	document.getElementById('Y' + tmpY).style.filter = 'Alpha(opacity=100)'
	document.getElementById('X' + tmpX).style.opacity = '1.00'
	document.getElementById('Y' + tmpY).style.opacity = '1.00'

	document.getElementById('cllX' + strX + 'Y' + strY).style.backgroundColor = '#000000'
	document.getElementById('cllX' + strX + 'Y' + strY).style.filter = 'Alpha(opacity=33)'
	document.getElementById('cllX' + strX + 'Y' + strY).style.opacity = '0.33'
	document.getElementById('X' + strX).style.backgroundColor = '#000000'
	document.getElementById('Y' + strY).style.backgroundColor = '#000000'
	document.getElementById('X' + strX).style.filter = 'Alpha(opacity=33)'
	document.getElementById('Y' + strY).style.filter = 'Alpha(opacity=33)'
	document.getElementById('X' + strX).style.opacity = '0.33'
	document.getElementById('Y' + strY).style.opacity = '0.33'
	tmpX = strX
	tmpY = strY
}

function getonGrd()
{
	document.getElementById('hvrX').style.display = 'block'
	document.getElementById('hvrY').style.display = 'block'
}

function getoffGrd()
{
	document.getElementById('hvrX').style.display = 'none'
	document.getElementById('hvrY').style.display = 'none'
}

window.onresize = function(e)
{
	Set_Window_Size()
	Write_Guide(true)
}


//---------------------------------------------- Tables

var empDat =
{
	a:['#ffcc00',	'#FFFF33',	'Argon',	'A'],
	b:['#3366ff',	'#6699FF',	'Boron',	'B'],
	m:['#000000',	'#333333',	'Multi',	'M'],
	n:['#ff6600',	'#FF9933',	'Paranid',	'P'],
	p:['#ff99cc',	'#FFCCFF',	'Pirates',	'Pir'],
	s:['#969696',	'#C9C9C9',	'Split',	'S'],
	t:['#99cc00',	'#CCFF33',	'Teladi',	'T'],
	x:['#ff0000',	'#FF3333',	'Xenon',	'X']
}
var facDat =
{
	Pr:{Cl:'#ff0000',	Ti:'Pirate Base',	Sm:'\u2014'},
	Sh:{Cl:'#0000ff',	Ti:'Shipyard',		Sm:'\u2014'},
	Dk:{Cl:'#00ff00',	Ti:'Equip. Dock',	Sm:'\u2014'},
	Tl:{Cl:'#00ff00',	Ti:'TL Ships',		Sm:'\u2666'},
	M1:{Cl:'#0000ff',	Ti:'M1 Ships',		Sm:'\u2666'},
	M2:{Cl:'#ff0000',	Ti:'M2 Ships',		Sm:'\u2666'}
}

function Sys_Func(Cx,Cy, No,Ws,So,Ea, Pr,Sh,Dk,Xt, Tl,M1,M2, Ep,Ti,Tx)
{
	this.Cx = Cx,	this.Cy = Cy
	this.No = No,	this.Ws = Ws,	this.So = So,	this.Ea = Ea		// North, west, south, east border type		(solid,dashed)
	this.Pr = Pr,	this.Sh = Sh,	this.Dk = Dk,	this.Xt = Xt		// Pirate, shipyard, dock, new in XT		(hidden,visible;no,yes)
	this.Tl = Tl,	this.M1 = M1,	this.M2 = M2				// TL, M1, M2					(integer)
	this.Ep = Ep,	this.Ti = Ti,	this.Tx = Tx				// Name, description				(string)
}

var secDat =
[
new Sys_Func( 0,0, 0,0,1,1, 0,1,1,0, 1,1,0,	'b', 'Kingdom End',			fillText),
new Sys_Func( 0,1, 1,0,1,1, 0,0,1,0, 0,0,0,	'a', 'Three Worlds',			fillText),
new Sys_Func( 0,2, 1,0,1,1, 0,0,0,0, 0,0,0,	'a', 'Cloud-\nbase Nw',			fillText),
new Sys_Func( 0,3, 1,0,1,1, 0,0,0,0, 1,0,0,	'a', 'Ringo Moon',			fillText),
new Sys_Func( 0,4, 1,0,1,1, 0,0,1,0, 0,1,0,	'a', 'Red Light',			fillText),
new Sys_Func( 0,5, 1,0,1,1, 0,0,0,0, 0,0,0,	'a', 'Cloud-\nbase SW',			fillText),
new Sys_Func( 0,6, 1,0,0,1, 0,0,0,0, 0,0,0,	'n', 'Emperor Mines',			fillText),
new Sys_Func( 1,0, 0,1,0,1, 0,0,0,0, 0,0,1,	'b', 'Rolks Drift',			fillText),
new Sys_Func( 1,1, 0,1,1,1, 0,0,0,0, 0,0,0,	'a', 'Power Circle',			fillText),
new Sys_Func( 1,2, 1,1,1,1, 0,0,0,0, 0,1,0,	'a', 'Herrons Nebula',			fillText),
new Sys_Func( 1,3, 1,1,1,1, 0,1,1,0, 1,0,1,	'a', 'Argon Prime',			fillText),
new Sys_Func( 1,4, 1,1,1,1, 0,0,0,0, 1,0,0,	'a', 'Light Home',			fillText),
new Sys_Func( 1,5, 1,1,0,1, 0,0,0,0, 0,0,0,	'a', 'Ore Belt',			fillText),
new Sys_Func( 1,6, 0,1,1,1, 0,1,1,0, 1,1,0,	'n', 'Paranid Prime',			fillText),
new Sys_Func( 1,7, 1,0,0,1, 0,0,0,0, 0,0,0,	'n', 'Empires Edge',			fillText),
new Sys_Func( 2,0, 0,1,0,1, 0,0,0,0, 0,0,0,	'b', 'Queens Space',			fillText),
new Sys_Func( 2,1, 0,1,1,0, 0,0,1,0, 0,0,0,	'a', 'Antigone Memorial',		fillText),
new Sys_Func( 2,2, 1,1,1,1, 0,0,0,0, 0,0,0,	'a', 'The Hole',			fillText),
new Sys_Func( 2,3, 1,1,1,0, 0,0,0,0, 0,1,0,	'a', 'The Wall',			fillText),
new Sys_Func( 2,4, 1,1,1,0, 0,0,0,0, 0,0,0,	'a', 'Presidents End',			fillText),
new Sys_Func( 2,5, 1,1,0,0, 0,0,1,0, 1,0,0,	'a', 'Cloud-\nbase SE',			fillText),
new Sys_Func( 2,6, 0,1,1,1, 0,0,0,0, 0,0,1,	'n', 'Priest Rings',			fillText),
new Sys_Func( 2,7, 1,1,0,1, 0,0,0,0, 0,0,0,	'n', 'Dukes Domain',			fillText),
new Sys_Func( 3,0, 0,1,1,1, 0,0,0,0, 1,0,0,	'b', 'Menelaus Frontier',		fillText),
new Sys_Func( 3,1, 1,0,1,0, 0,0,1,0, 0,0,0,	'b', 'Rolks Fate',			fillText),
new Sys_Func( 3,2, 1,1,1,0, 1,0,0,0, 0,0,0,	'b', 'Atreus Clouds',			fillText),
new Sys_Func( 3,3, 1,0,1,1, 0,0,0,0, 0,0,0,	'p', 'Farnhams Legend',			fillText),
new Sys_Func( 3,4, 1,0,1,1, 0,0,0,0, 0,0,0,	'p', 'Elanas Fortune',			fillText),
new Sys_Func( 3,5, 1,0,1,1, 0,0,0,0, 0,0,0,	'p', 'Split Fire',			fillText),
new Sys_Func( 3,6, 1,1,1,0, 1,0,0,0, 0,0,0,	'n', 'Priest Pity',			fillText),
new Sys_Func( 3,7, 1,1,1,0, 0,0,1,0, 1,0,0,	'n', 'Emperors Ridge',			fillText),
new Sys_Func( 3,8, 1,0,1,0, 0,0,0,1, 0,0,0,	'n', 'Pontifex Realm',			fillText),
new Sys_Func( 3,9, 1,0,0,1, 0,1,1,1, 1,0,1,	'n', 'Trinity Sanctum',			fillText),
new Sys_Func( 4,0, 0,1,1,1, 0,0,1,0, 0,0,0,	't', 'Ceos Buckzoid',			fillText),
new Sys_Func( 4,1, 1,0,1,1, 0,0,0,0, 0,0,0,	't', 'Profit Share',			fillText),
new Sys_Func( 4,2, 1,0,0,1, 0,0,0,0, 0,0,0,	't', 'Space-\nweed\nDrift',		fillText),
new Sys_Func( 4,3, 0,1,1,0, 0,0,0,0, 0,0,0,	'p', 'Bala Gis Joy',			fillText),
new Sys_Func( 4,4, 1,1,1,0, 0,0,0,0, 0,0,0,	'p', 'Olmanc-\nkenslats Treaty',	fillText),
new Sys_Func( 4,5, 1,1,1,0, 1,0,0,0, 0,0,0,	'p', 'Brennans Triumph',		fillText),
new Sys_Func( 4,6, 1,0,0,1, 0,0,0,0, 0,0,0,	'p', 'Dannas Chance',			fillText),
new Sys_Func( 4,9, 0,1,0,1, 0,0,0,1, 0,0,0,	'n', 'Preachers Refuge',		fillText),
new Sys_Func( 5,0, 0,1,1,1, 0,0,0,0, 0,0,0,	't', 'Teladi Gain',			fillText),
new Sys_Func( 5,1, 1,1,1,0, 0,1,1,0, 1,0,1,	't', 'Seizewell',			fillText),
new Sys_Func( 5,2, 1,1,1,0, 0,0,0,0, 0,1,0,	't', 'Greater Profit',			fillText),
new Sys_Func( 5,3, 1,0,1,0, 0,0,0,0, 0,0,0,	't', 'Blue Profit',			fillText),
new Sys_Func( 5,4, 1,0,1,0, 0,0,0,0, 1,0,0,	't', 'Ceos Sprite',			fillText),
new Sys_Func( 5,5, 1,0,0,1, 1,0,1,0, 0,0,1,	't', 'Company Pride',			fillText),
new Sys_Func( 5,6, 0,1,0,1, 0,0,0,0, 0,0,0,	'p', 'Nopileos Memorial',		fillText),
new Sys_Func( 5,9, 0,1,0,1, 0,0,0,1, 0,0,0,	'b', 'Shore of Infinity',		fillText),
new Sys_Func( 6,0, 0,1,1,0, 0,0,1,0, 0,0,1,	's', 'Family Whi',			fillText),
new Sys_Func( 6,1, 1,0,1,0, 0,0,0,0, 0,0,0,	's', 'Family Zein',			fillText),
new Sys_Func( 6,2, 1,0,1,1, 0,0,0,0, 0,0,0,	's', 'Thuroks Pride',			fillText),
new Sys_Func( 6,3, 1,0,1,1, 0,0,0,0, 1,0,0,	's', 'Chins Fire',			fillText),
new Sys_Func( 6,4, 1,0,1,0, 0,0,0,0, 0,0,0,	's', 'Family Chin',			fillText),
new Sys_Func( 6,5, 1,1,1,0, 0,0,1,0, 0,0,0,	's', 'Thuroks Beard',			fillText),
new Sys_Func( 6,6, 1,1,0,1, 0,0,0,0, 0,0,0,	'p', 'Hatikvahs Faith',			fillText),
new Sys_Func( 6,9, 0,1,0,1, 0,1,1,1, 1,0,0,	'b', 'Lucky Planets',			fillText),
new Sys_Func( 7,2, 0,1,1,0, 0,1,1,0, 1,1,0,	's', 'Family Pride',			fillText),
new Sys_Func( 7,3, 1,1,0,1, 1,0,0,0, 0,0,0,	's', 'Chins Clouds',			fillText),
new Sys_Func( 7,6, 0,1,1,0, 0,0,0,1, 0,0,0,	'a', 'Aladna Hill',			fillText),
new Sys_Func( 7,7, 1,0,1,0, 0,1,1,1, 1,0,0,	'a', 'Light of Heart',			fillText),
new Sys_Func( 7,8, 1,0,1,0, 0,0,0,1, 0,0,0,	'a', 'Montalaar',			fillText),
new Sys_Func( 7,9, 1,1,0,1, 0,0,0,1, 0,0,0,	'b', 'Rolks Legacy',			fillText),
new Sys_Func( 8,3, 0,1,0,1, 0,0,0,1, 0,0,0,	's', 'Tharkas Sun',			fillText),
new Sys_Func( 8,9, 0,1,0,1, 0,0,1,1, 1,0,0,	'b', 'Great Trench',			fillText),
new Sys_Func( 9,3, 0,1,1,0, 0,1,1,1, 1,0,0,	's', 'Chaos Defeat',			fillText),
new Sys_Func( 9,4, 1,0,0,1, 0,0,0,1, 0,0,0,	's', 'Patriarchs Keep',			fillText),
new Sys_Func( 9,8, 0,0,1,1, 1,0,0,1, 0,0,0,	't', 'New Income',			fillText),
new Sys_Func( 9,9, 1,1,0,0, 0,0,0,1, 0,0,0,	't', 'Ceos Doubt',			fillText),
new Sys_Func(10,4, 0,1,1,0, 0,0,1,1, 0,0,0,	't', 'Two Grand',			fillText),
new Sys_Func(10,5, 1,0,0,1, 0,0,0,1, 0,0,0,	't', 'Profit Center Alpha',		fillText),
new Sys_Func(10,7, 0,0,1,1, 0,0,0,1, 0,0,0,	't', 'Eighteen Million',		fillText),
new Sys_Func(10,8, 1,1,0,0, 0,1,1,1, 1,1,0,	't', 'Ianamus Zura',			fillText),
new Sys_Func(11,5, 0,1,1,0, 0,1,1,1, 1,1,0,	't', 'PTNI Head-\nquarters',		fillText),
new Sys_Func(11,6, 1,0,1,1, 0,0,0,1, 0,0,0,	't', 'Scale Plate Green',		fillText),
new Sys_Func(11,7, 1,1,0,0, 0,0,0,1, 0,3,7,	'x', 'Xenon System',			fillText),
new Sys_Func(12,6, 0,1,0,1, 1,0,0,1, 0,0,0,	'a', 'Nyanas Hideout',			fillText),
new Sys_Func(13,6, 0,1,0,1, 0,1,1,1, 1,1,0,	'a', 'Omicron Lyrae',			fillText),
new Sys_Func(14,6, 0,1,0,1, 0,0,0,1, 0,0,0,	'a', 'Treasure Chest',			fillText),
new Sys_Func(15,5, 0,0,1,1, 0,1,0,1, 0,2,2,	'x', 'Xenon System',			fillText),
new Sys_Func(15,6, 1,1,0,0, 0,0,1,1, 0,0,0,	'a', 'Black Hole Sun',			fillText),
new Sys_Func(16,3, 0,0,1,1, 1,0,0,1, 0,0,0,	's', 'Ghinns Escape',			fillText),
new Sys_Func(16,4, 1,0,1,0, 0,1,1,1, 1,0,0,	's', 'Family Njy',			fillText),
new Sys_Func(16,5, 1,1,0,0, 0,0,0,1, 0,0,0,	's', 'Thyns Abbys',			fillText),
new Sys_Func(17,0, 0,0,1,0, 0,0,0,0, 0,2,1,	'x', 'Xenon System',			fillText),
new Sys_Func(17,1, 1,0,0,1, 0,0,1,0, 0,0,0,	'm', 'Gestu Fune (9 Docks)',		fillText),
new Sys_Func(17,3, 0,1,0,1, 0,0,0,1, 0,0,0,	'b', 'Hilas Joy',			fillText),
new Sys_Func(18,1, 0,1,1,1, 0,0,1,1, 0,0,1,	'b', 'Menelaus Paradise',		fillText),
new Sys_Func(18,2, 1,0,1,0, 0,0,0,1, 0,0,0,	'b', 'Bluish Snout',			fillText),
new Sys_Func(18,3, 1,1,0,0, 0,1,1,1, 1,1,0,	'b', 'Ocean of Fantasy',		fillText),
new Sys_Func(19,0, 0,0,1,0, 0,0,0,1, 0,'?','?',	'x', 'Xenon System',			fillText),
new Sys_Func(19,1, 1,1,0,0, 1,0,0,1, 0,'?','?',	'x', 'Xenon System',			fillText)
]                                      


//---------------------------------------------- Writing

function Write_Guide(thisPass)
{
	var thisObject = document.getElementById('mapBox')
	var outerWid = winWid - pnlWid - brdHgh * 2
	var outerHgh = winHgh - brdHgh * 2
	thisObject.style.width   = outerWid + 'px'
	thisObject.style.height  = outerHgh + 'px'
	thisObject = document.getElementById('map')
	thisObject.style.width   = outerWid - brdHgh * 2 + 'px'
	thisObject.style.height  = barHgh - brdHgh * 2 + 'px'
	thisObject.onclick = Expand_Map
	thisObject = document.getElementById('mapIn')
	thisObject.style.width   = outerWid + 'px'
	thisObject.style.height  = outerHgh - barHgh + 'px'

	thisObject = document.getElementById('detBox')
	outerWid = pnlWid - brdHgh * 2
	outerHgh = pnlDat['det'][1] - brdHgh * 2
//	thisObject.style.width   = outerWid + 'px'
//	thisObject.style.height  = outerHgh + 'px'
	thisObject = document.getElementById('det')
	thisObject.style.width   = outerWid - brdHgh * 2 + 'px'
	thisObject.style.height  = barHgh - brdHgh * 2 + 'px'
	thisObject.onclick = Expand_Rgt_Panels
	thisObject = document.getElementById('detIn')
	thisObject.style.display = pnlDat['det'][2]
	thisObject.style.width   = outerWid - padHgh * 2 + 'px'
	thisObject.style.height  = outerHgh - padHgh * 2 - barHgh + 'px'
	thisObject = document.getElementById('detFld')
	thisObject.style.width   = outerWid - padHgh * 2 - brdHgh * 2 - 4 + 'px'
	thisObject.style.height  = outerHgh - padHgh * 2 - brdHgh * 2 - 4 - 80 - barHgh + 'px'

	thisObject = document.getElementById('keyBox')
	outerWid = pnlWid - brdHgh * 2
	outerHgh = pnlDat['key'][1] - brdHgh * 2
//	thisObject.style.width   = outerWid + 'px'
//	thisObject.style.height  = outerHgh + 'px'
	thisObject = document.getElementById('key')
	thisObject.style.width   = outerWid - brdHgh * 2 + 'px'
	thisObject.style.height  = barHgh - brdHgh * 2 + 'px'
	thisObject.onclick = Expand_Rgt_Panels
	thisObject = document.getElementById('keyIn')
	thisObject.style.display = pnlDat['key'][2]
	thisObject.style.width   = outerWid - padHgh * 2 + 'px'
	thisObject.style.height  = outerHgh - padHgh * 2 - barHgh + 'px'

	thisObject = document.getElementById('rfrBox')
	var tempHgh = 0
	for (var i in pnlDat)
	{
		if (pnlDat[i][2] == 'block')
			tempHgh += pnlDat[i][1]
		else
			tempHgh += barHgh + brdHgh * 2
	}
	outerWid = pnlWid - brdHgh * 2
	outerHgh = winHgh - tempHgh - brdHgh * 2
//	thisObject.style.width   = outerWid + 'px'
//	thisObject.style.height  = outerHgh + 'px'
	thisObject = document.getElementById('rfr')
	thisObject.style.width   = outerWid - brdHgh * 2 + 'px'
	thisObject.style.height  = barHgh - brdHgh * 2 + 'px'
	thisObject.onclick = Expand_Rgt_Panels
	thisObject = document.getElementById('rfrIn')
	thisObject.style.display = 'block'
	thisObject.style.width   = outerWid - padHgh * 2 + 'px'
	thisObject.style.height  = outerHgh - padHgh * 2 - barHgh + 'px'

	thisObject = document.getElementById('panel')
	thisObject.style.display = 'block'
	thisObject.style.width   = pnlWid + 'px'
	thisObject.style.height  = winHgh + 'px'
	document.getElementById('cllFld').onmouseover = getonGrd
	document.getElementById('cllFld').onmouseout = getoffGrd
	document.getElementById('rfr').onclick = Expand_Rfr_Panel

	if (thisPass)
		return
	Write_Labels()
	Write_Cells()
	Write_Details()
	Write_Reference()
	Write_Legend()
}

function Write_Labels()
{
	var thisLevel0, thisLevel1, thisLevel2
	thisLevel0 = document.getElementById('mapIn')
	for (var i = 0; i < cllXNm; i ++)
	{
		thisLevel1 = document.createElement('table')
		thisLevel1.id = 'X' + i
		thisLevel1.className = 'lblx'
		thisLevel1.style.left = i * cllMax + barHgh - brdHgh + 'px'
		thisLevel1.style.top  = 0 + 'px'
		thisLevel1.style.borderSpacing = 0
		thisLevel2 = document.createElement('tr')
		thisLevel3 = document.createElement('td')
		thisLevel3.style.width = cllMax - 2 * brdHgh + 'px'
		thisLevel3.style.height = cllMin - 2 * brdHgh + 'px'
		thisLevel4 = document.createTextNode(i+1)
		thisLevel3.appendChild(thisLevel4)
		thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
		thisLevel0.appendChild(thisLevel1)
	}
	for (var i = 0; i < cllYNm; i ++)
	{
		thisLevel1 = document.createElement('table')
		thisLevel1.id = 'Y' + i
		thisLevel1.className = 'lbly'
		thisLevel1.style.left = 0 + 'px'
		thisLevel1.style.top  = i * cllMax + barHgh - brdHgh + 'px'
		thisLevel1.style.borderSpacing = 0
		thisLevel2 = document.createElement('tr')
		thisLevel3 = document.createElement('td')
		thisLevel3.style.width = cllMin - 2 * brdHgh + 'px'
		thisLevel3.style.height = cllMax - 2 * brdHgh + 'px'
		thisLevel4 = document.createTextNode(i+1)
		thisLevel3.appendChild(thisLevel4)
		thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
		thisLevel0.appendChild(thisLevel1)
	}
}

function Write_Cells()
{
	var thisLevel0, thisLevel1, thisLevel2, thisLevel3, thisLevel4, thisLevel5
	var thisLevel0 = document.getElementById('cllFld')
	thisLevel0.style.left = cllMin - brdHgh + 'px';
	thisLevel0.style.top = cllMin - brdHgh + 'px';
	for (var i = 0, n = secDat.length; i < n; i++)
	{
		var thisSec = secDat[i]
		var thisEmp = empDat[thisSec.Ep]
		var thisLft = thisSec.Cx * cllMax + 'px'
		var thisTop = thisSec.Cy * cllMax + 'px'
		var thisWid = cllMax + 'px'
		var thisHgh = cllMax + 'px'
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'sqrX' + thisSec.Cx + 'Y' + thisSec.Cy
		thisLevel1.className = 'sqr'
		thisLevel1.style.left   = thisLft
		thisLevel1.style.top    = thisTop
		thisLevel1.style.width  = thisWid
		thisLevel1.style.height = thisHgh
		thisLevel1.style.backgroundColor = thisEmp[0]
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'legtop'
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnPrX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'dot icn'
				thisLevel3.style.color = facDat.Pr.Cl
				thisLevel3.style.display = thisSec.Pr == 1 ? 'block' : 'none'
					thisLevel4 = document.createTextNode(facDat.Pr.Sm)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnShX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'dot icn'
				thisLevel3.style.color = facDat.Sh.Cl
				thisLevel3.style.display = thisSec.Sh == 1 ? 'block' : 'none'
					thisLevel4 = document.createTextNode(facDat.Sh.Sm)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnDkX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'dot icn'
				thisLevel3.style.color = facDat.Dk.Cl
				thisLevel3.style.display = thisSec.Dk == 1 ? 'block' : 'none'
					thisLevel4 = document.createTextNode(facDat.Dk.Sm)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'legbot'
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnTlX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'icn'
				thisLevel3.style.display = thisSec.Tl == 1 ? 'block' : 'none'
					thisLevel4 = document.createElement('span')
					thisLevel4.className = 'dot'
					thisLevel4.style.color = facDat.Tl.Cl
						thisLevel5 = document.createTextNode(facDat.Tl.Sm)
					thisLevel4.appendChild(thisLevel5)
				thisLevel3.appendChild(thisLevel4)
					thisLevel4 = document.createTextNode(thisSec.Tl)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnMlX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'icn'
				thisLevel3.style.display = thisSec.M1 == 1 ? 'block' : 'none'
					thisLevel4 = document.createElement('span')
					thisLevel4.className = 'dot'
					thisLevel4.style.color = facDat.M1.Cl
						thisLevel5 = document.createTextNode(facDat.M1.Sm)
					thisLevel4.appendChild(thisLevel5)
				thisLevel3.appendChild(thisLevel4)
					thisLevel4 = document.createTextNode(thisSec.M1)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
				thisLevel3 = document.createElement('span')
				thisLevel3.id = 'icnM2X' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'icn'
				thisLevel3.style.display = thisSec.M2 == 1 ? 'block' : 'none'
					thisLevel4 = document.createElement('span')
					thisLevel4.className = 'dot'
					thisLevel4.style.color = facDat.M2.Cl
						thisLevel5 = document.createTextNode(facDat.M2.Sm)
					thisLevel4.appendChild(thisLevel5)
				thisLevel3.appendChild(thisLevel4)
					thisLevel4 = document.createTextNode(thisSec.M2)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'arwW'
			thisLevel2.style.display = thisSec.Ws == 1 ? 'block' : 'none'
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'arwN'
			thisLevel2.style.display = thisSec.No == 1 ? 'block' : 'none'
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'arwE'
			thisLevel2.style.display = thisSec.Ea == 1 ? 'block' : 'none'
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('div')
			thisLevel2.className = 'arwS'
			thisLevel2.style.display = thisSec.So == 1 ? 'block' : 'none'
		thisLevel1.appendChild(thisLevel2)
	thisLevel0.appendChild(thisLevel1)
		thisLevel1 = document.createElement('table')
		thisLevel1.className = 'huh'
		thisLevel1.style.borderSpacing = 0
		thisLevel1.style.left   = thisLft
		thisLevel1.style.top    = thisTop
		thisLevel1.style.width  = thisWid
		thisLevel1.style.height = thisHgh
			thisLevel2 = document.createElement('tr')
				thisLevel3 = document.createElement('td')
				thisLevel3.id = 'cllX' + thisSec.Cx + 'Y' + thisSec.Cy
				thisLevel3.className = 'cll'
				thisLevel3.style.borderLeftStyle   = (thisSec.Ws == 1) ? 'dashed' : 'solid'
				thisLevel3.style.borderTopStyle    = (thisSec.No == 1) ? 'dashed' : 'solid'
				thisLevel3.style.borderRightStyle  = (thisSec.Ea == 1) ? 'dashed' : 'solid'
				thisLevel3.style.borderBottomStyle = (thisSec.So == 1) ? 'dashed' : 'solid'
				thisLevel3.style.left   = brdHgh + 'px'
				thisLevel3.style.top    = brdHgh + 'px'
				thisLevel3.style.width  = thisWid - brdHgh * 2
				thisLevel3.style.height = thisHgh - brdHgh * 2
				thisLevel3.onclick = Select_Cell
				thisLevel3.onmouseover = Highlight_Cll_On
				thisLevel3.onmouseout = Highlight_Cll_Off
					thisLevel4 = document.createTextNode(thisSec.Ti)
				thisLevel3.appendChild(thisLevel4)
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
	thisLevel0.appendChild(thisLevel1)
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'ovrX' + thisSec.Cx + 'Y' + thisSec.Cy
		thisLevel1.className = 'ovr'
		thisLevel1.style.left   = thisLft
		thisLevel1.style.top    = thisTop
		thisLevel1.style.width  = thisWid
		thisLevel1.style.height = thisHgh
	thisLevel0.appendChild(thisLevel1)
	}
}

function Write_Details()
{
	var thisLevel0, thisLevel1, thisLevel2, thisLevel3
	thisLevel0 = document.getElementById('detLs')
	for (var l in facDat)
	{
		var thisFac = facDat[l]
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'det' + l
		thisLevel1.className = 'detind'
			thisLevel2 = document.createElement('span')
			thisLevel2.className = 'dot'
			thisLevel2.style.color = thisFac.Cl
				thisLevel3 = document.createTextNode(thisFac.Sm)
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createElement('span')
			thisLevel2.id = 'detnum' + l
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createTextNode(' ' + thisFac.Ti)
		thisLevel1.appendChild(thisLevel2)
	thisLevel0.appendChild(thisLevel1)
	}
}

function Write_Reference()
{
	var thisLevel0, thisLevel1, thisLevel2, thisLevel3, thisLevel4
	thisLevel0 = document.getElementById('rfrIn')
	for (var l in facDat)
	{
		var thisFac = facDat[l]
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'rfr' + l
		thisLevel1.className = 'bld'
			thisLevel2 = document.createElement('span')
			thisLevel2.id = 'rfr' + l + 'Dot'
			thisLevel2.className = 'dot'
				thisLevel3 = document.createTextNode('\u25a0')
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createTextNode(' ' + thisFac.Ti)
		thisLevel1.appendChild(thisLevel2)
		thisLevel1.onclick = Expand_Ref_Nodes
	thisLevel0.appendChild(thisLevel1)
		thisLevel1 = document.createElement('div')
		thisLevel1.onmouseover = getonGrd
		thisLevel1.onmouseout = getoffGrd
		thisLevel1.id = 'rfr' + l + 'In'
		thisLevel1.className = 'rfrind'
		thisLevel1.style.display = 'none'
		for (var i = 0, n = secDat.length; i < n; i++)
		{
			var thisSec = secDat[i]
			var thisEmp = empDat[thisSec.Ep]
			for (var j in thisSec)
			{
				if ((j == l) && (thisSec[j] != 0))
				{
					thisLevel2 = document.createElement('div')
					thisLevel2.id = 'rfrX' + thisSec.Cx + 'Y' + thisSec.Cy
					thisLevel2.className = 'ent'
					thisLevel2.onclick = Select_Cell
					thisLevel2.onmouseover = Highlight_Cll_On
					thisLevel2.onmouseout = Highlight_Cll_Off
						thisLevel3 = document.createElement('span')
						thisLevel3.className = 'dot'
							thisLevel4 = document.createTextNode('\u25cf')
						thisLevel3.appendChild(thisLevel4)
					thisLevel2.appendChild(thisLevel3)
						thisLevel3 = document.createTextNode(' ' + thisSec.Ti + ' (')
					thisLevel2.appendChild(thisLevel3)
						thisLevel3 = document.createElement('span')
						thisLevel3.style.color = thisEmp[0]
							thisLevel4 = document.createTextNode(thisEmp[3])
						thisLevel3.appendChild(thisLevel4)
					thisLevel2.appendChild(thisLevel3)
						thisLevel3 = document.createTextNode(')')
					thisLevel2.appendChild(thisLevel3)
				thisLevel1.appendChild(thisLevel2)
				}
			}
		}
	thisLevel0.appendChild(thisLevel1)
	}
}

function Write_Legend()
{
	var thisLevel0, thisLevel1, thisLevel2, thisLevel3
	thisLevel0 = document.getElementById('keyRac')
	for (var k in empDat)
	{
		var thisEmp = empDat[k]
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'keyR' + k
		thisLevel1.onclick = Toggle_Key_Items
		thisLevel1.className = 'bld'
			thisLevel2 = document.createElement('span')
			thisLevel2.id = 'keyR' + k + 'Dot'
			thisLevel2.className = 'dot'
			thisLevel2.style.color = thisEmp[0]
				thisLevel3 = document.createTextNode('\u25a0')
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createTextNode(' ' + thisEmp[2] + ' (' + thisEmp[3] + ')')
		thisLevel1.appendChild(thisLevel2)
	thisLevel0.appendChild(thisLevel1)
	}
	thisLevel0 = document.getElementById('keyObj')
	for (var l in facDat)
	{
		var thisFac = facDat[l]
		thisLevel1 = document.createElement('div')
		thisLevel1.id = 'keyL' + l
		thisLevel1.className = 'bld'
			thisLevel2 = document.createElement('span')
			thisLevel2.id = 'keyL' + l + 'Dot'
			thisLevel2.className = 'dot'
			thisLevel2.style.color = thisFac.Cl
				thisLevel3 = document.createTextNode(thisFac.Sm)
			thisLevel2.appendChild(thisLevel3)
		thisLevel1.appendChild(thisLevel2)
			thisLevel2 = document.createTextNode(' ' + thisFac.Ti)
		thisLevel1.appendChild(thisLevel2)
	thisLevel0.appendChild(thisLevel1)
	}
}
